
#property copyright ""
#property link      ""

//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_style1 STYLE_SOLID
#property indicator_width1 2
#property indicator_color2 Yellow
#property indicator_style2 STYLE_DOT
#property indicator_level1 50
#property indicator_levelcolor Aqua
#property indicator_levelstyle STYLE_DOT
//----
extern string NOTESETTINGS   = " --- INDICATOR SETTINGS ---";
extern int    RSI_Period     = 14;
extern int    SF             = 5;

extern string note           = "turn on Alert = true; turn off = false";
extern bool   alertsOn       = true;
extern bool   alertsOnCurrent= true;
extern bool   alertsMessage  = true;
extern bool   alertsSound    = true;
extern bool   alertsEmail    = false;
extern string soundfile      = "alert.wav";
//----

double TrLevelSlow[];
double AtrRsi[];
double MaAtrRsi[];
double Rsi[];
double RsiMa[];
double trend[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   
//----
   IndicatorBuffers(6);
   SetIndexBuffer(0, RsiMa);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(0, "Value 1");
   SetIndexStyle(1, DRAW_LINE, STYLE_DOT);
   SetIndexBuffer(1, TrLevelSlow);
   SetIndexLabel(1, "Value 2");
   SetIndexBuffer(2, AtrRsi);
   SetIndexBuffer(3, MaAtrRsi);
   SetIndexBuffer(4, Rsi);
   SetIndexBuffer(5,trend);
   IndicatorShortName(StringConcatenate("QQE(", SF, ")"));
//----
  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

   
   
int start()
{
   double tr;
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
         
   for (i=limit; i >= 0; i--)  Rsi[i]=iRSI(NULL, 0, RSI_Period, PRICE_CLOSE, i);
   for (i=limit; i >= 0; i--) 
   {
      RsiMa[i]=iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
      AtrRsi[i]=MathAbs(RsiMa[i + 1] - RsiMa[i]);
   }
   for (i=limit; i >= 0; i--)  MaAtrRsi[i]=iMAOnArray(AtrRsi, 0, RSI_Period, 0, MODE_EMA, i);

   for (i=limit; i >= 0; i--) 
   {
      double rsi1=iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
      double rsi0=iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
      double dar=iMAOnArray(MaAtrRsi, 0, RSI_Period, 0, MODE_EMA, i) * 4.236;
      double dv=tr;
      if (rsi0 < tr)
        {
         tr=rsi0 + dar;
         if (rsi1 < dv)
            if (tr > dv)
               tr=dv;
        }
      else if (rsi0 > tr)
           {
            tr=rsi0 - dar;
            if (rsi1 > dv)
               if (tr < dv)
                  tr=dv;
           }
      TrLevelSlow[i]=tr;
      rsi1=rsi0;
      trend[i] = trend[i+1];
     if (RsiMa[i]>TrLevelSlow[i]) trend[i] = 1;
     if (RsiMa[i]<TrLevelSlow[i]) trend[i] =-1;
     }
     if (alertsOn)
         {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," QQE ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," QQE "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

     